<?php

// model/Registration_model.php

class Registration_model extends Model {

    public function courses() {
        $statement = $this->db->query("SELECT * FROM courses");
        return $statement->fetchall();
    }

    public function register($firstname, $lastname, $courses) {
        /* Ajouter une inscription dans la base de données */
        $this->db->beginTransaction();
        $query1 = 'INSERT INTO students(firstname, lastname) VALUES (?, ?)';
        $statement = $this->db->prepare($query1);
        $success = $statement->execute([$firstname, $lastname]);
        if (!$success) {
            $this->db->rollback();
            return false;
        }
        $student_id = $this->db->lastInsertId();

        $query = 'INSERT INTO choices(student_id, course_id) VALUES (?, ?)';
        $statement = $this->db->prepare($query);
        foreach ($courses as $course_id) {
            $success = $statement->execute([$student_id, $course_id]);
            if (!$success) {
                $this->db->rollback();
                return false;
            }
        }
        $this->db->commit();
        return true;
    }

    public function registrations() {
        $query = "SELECT students.firstname,students.lastname,"
                . "group_concat(courses.name, ', ') "
                . "as courses "
                . "FROM students "
                . "LEFT JOIN choices ON students.id = choices.student_id "
                . "LEFT JOIN courses ON choices.course_id = courses.id "
                . "GROUP BY students.id";

        $statement = $this->db->query($query);
        return $statement->fetchall();
    }

}
